﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;

	public class Fibonacci extends Sprite
	{
		private var max:Number;
		private var fibonacci:Number;
		private var accident:Number;
		private var rapport:Number;
		private var rad:Number;
		private var growth:Number;
		private var sc_x:Number;
		private var sc_y:Number;
		private var rpx:Number;
		private var rpy:Number;
		private var cur:Number;
		private var rot:Number;
		
		// New values
		/////////////
		
		private var colorfact:uint=200;
		private var large:Number;
		
		
		
		
		public function Fibonacci()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
			setup();
		}
		private function setup():void
		{
			max			= 1000;
			fibonacci	= 1/1.618033989;
			accident	= .998;
			rapport 	= 360-360*fibonacci - 5;
			rad 		= 40;
			growth		= 1.005;
			sc_x		= 12;
			sc_y		= 7;
			rpx			= 1.001;
			rpy			= 1.018;
		
			cur			= max;
			rot			= 0;
			rapport 	= 70;
			large 		= 1;
		}
		
		private function addedHandler(e:Event):void
		{
			addEventListener(Event.ENTER_FRAME, enterhandler);
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			stage.addEventListener(MouseEvent.CLICK, clickHandler);
		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			graphics.clear();
			setup();
			//removeEventListener(Event.ENTER_FRAME,enterhandler);
		}
		
		private function clickHandler(e:MouseEvent):void
		{
			graphics.clear();
			setup();
			addEventListener(Event.ENTER_FRAME, enterhandler);
			large += 10*(Math.random()*10);
			rapport = 15+mouseX/10.9;
		}
		
		private function enterhandler(e:Event):void
		{
			if(cur)
			{
				cur--;
				large +=rapport/300;
				colorfact++;
				//rapport*=accident;
				//sc_x*=rpx;
				//sc_y*=rpy;
				rot += rapport;
				//rot-= new int(rot/360)*360;
				rad *= growth;
				var x:Number = stage.stageWidth/2+Math.cos(rot * Math.PI/180) *rad;
				var y:Number = stage.stageHeight/2+Math.sin(rot * Math.PI/180) *rad;
				//var z:Number = rapport; 
				if(cur!= (max-1)){
					graphics.lineStyle(large/2,0x111111*colorfact,.9);
					graphics.lineTo(x,y);
				}else{
					graphics.moveTo(x,y);
				}
			}else{
				removeEventListener(Event.ENTER_FRAME,enterhandler);
			}
		}
		
	}
}